/* common.h
 *
 * Copyright (C) Angus J. C. Duggan, 1996
 *
 * Common definitions for lpr/lpq/lprm for Windows NT
 *
 */

#define PRINTER "PRINTER"
#define PRINTHOST "PRINTHOST"
#define REMOTEPORTNO ((short)515)
#define LOCALPORTMIN ((short)721)
#define LOCALPORTMAX ((short)731)

#define DEFAULTUSER "nobody"

typedef enum { LPD_START = 1, LPD_PRINT = 2, LPD_SHORTQ = 3,
	       LPD_LONGQ = 4, LPD_REMOVE = 5 } LPDCommand ;

typedef enum { LPR_ABORT = 1, LPR_CONTROL = 2, LPR_DATA = 3 } LPRCommand ;

typedef enum { FMT_DVI = 'd', FMT_TEXT = 'f', FMT_CTRL = 'l',
	       FMT_DITROFF = 'n', FMT_PS = 'o', FMT_PAGE = 'p',
	       FMT_TROFF = 't' } LPRFormat ;

char *program ;

void *xalloc(void *ptr, size_t size) ;

void error(char *format, ...) ;
void warning(char *format, ...) ;

int LPD(char *printer, char *hostname, int (*fn)(char *printer, char *hostname,
						 SOCKET printsock,
						 va_list args), ...) ;
int Acknowledge(int ping) ;
int Command(char *format, ...) ;

int NextJobNumber(void) ;
char *DefaultHost(char *printer) ;
